'+--------------------------------------------------------------------------+
'|                                                                          |
'|                               Soundscape A                               |
'|                          BassBox OpenGL plugin                           |
'|                                                                          |
'|                              Version 1.00                                |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                           Author Charles Pegge                           |
'|                                                                          |
'|                            copyright(c) 2007                             |
'|                                                                          |
'|                Patrice Terrier http://www.zapsolution.com                |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 12-15-2007 (MM-DD-YYYY)            |
'|                        Last revised : 01-25-2008 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+
'

#COMPILE DLL "SoundscapeA.dll"

#INCLUDE "Include\PB_OPENGL_MACROS.inc"
'#INCLUDE "TB_GDIPLUS.INC" 'for GDI+ Extension (pre-XP systems requires GDIplus.dll redistibutable)
'#INCLUDE "Include\Geometrica.inc"

    %BBP_NO_IOFILE = 1
    %BBP_NO_REGISTRY = 1
    %BBP_NO_GLFONT = 1

#INCLUDE "Include\BBPlugin.inc"


'/* ErrorCode */
' GL_NO_ERROR                       = 0
' GL_INVALID_ENUM                   = &H0500
' GL_INVALID_VALUE                  = &H0501
' GL_INVALID_OPERATION              = &H0502
' GL_STACK_OVERFLOW                 = &H0503
' GL_STACK_UNDERFLOW                = &H0504
' GL_OUT_OF_MEMORY                  = &H0505






DECLARE FUNCTION LoadLibrary LIB "KERNEL32.DLL" ALIAS "LoadLibraryA" (lpLibFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION FreeLibrary LIB "KERNEL32.DLL" ALIAS "FreeLibrary" (BYVAL hLibModule AS DWORD) AS LONG
DECLARE FUNCTION GetProcAddress LIB "KERNEL32.DLL" ALIAS "GetProcAddress" (BYVAL hModule AS DWORD, lpProcName AS ASCIIZ) AS LONG
DECLARE FUNCTION QueryPerformanceCounter LIB "KERNEL32.DLL" ALIAS "QueryPerformanceCounter" (lpPerformanceCount AS QUAD) AS LONG
DECLARE FUNCTION QueryPerformanceFrequency LIB "KERNEL32.DLL" ALIAS "QueryPerformanceFrequency" (lpFrequency AS QUAD) AS LONG
DECLARE FUNCTION wglGetProcAddress LIB "OPENGL32.DLL" ALIAS "wglGetProcAddress" (lpszProc AS ASCIIZ) AS DWORD


TYPE RECT
    nLeft AS LONG
    nTop AS LONG
    nRight AS LONG
    nBottom AS LONG
END TYPE



' PERFORMANCE

' ========================================================================================
SUB TimeStamp(tick AS QUAD) ' CPU Clock count

  '---------------------------'
  '                           ' approx because it is not a serialised instruction
  '                           ' it may execute before or after other instructions
  '                           ' in the pipeline.
  ! mov ebx,tick              ' var address where count is to be stored.
  ! db  &h0f,&h31             ' RDTSC read time-stamp counter into edx:eax hi lo.
  ! mov [ebx],eax             ' save low order 4 bytes.
  ! mov [ebx+4],edx           ' save high order 4 bytes.
  '---------------------------'

END SUB
' ========================================================================================




' IMAGING
' ========================================================================================
' USING GDIplus
' ========================================================================================


' enum RotateFlipType

%RotateNoneFlipNone = 0
%Rotate90FlipNone   = 1
%Rotate180FlipNone  = 2
%Rotate270FlipNone  = 3

%RotateNoneFlipX    = 4
%Rotate90FlipX      = 5
%Rotate180FlipX     = 6
%Rotate270FlipX     = 7

%RotateNoneFlipY    = %Rotate180FlipX
%Rotate90FlipY      = %Rotate270FlipX
%Rotate180FlipY     = %RotateNoneFlipX
%Rotate270FlipY     = %Rotate90FlipX

%RotateNoneFlipXY   = %Rotate180FlipNone
%Rotate90FlipXY     = %Rotate270FlipNone
%Rotate180FlipXY    = %RotateNoneFlipNone
%Rotate270FlipXY    = %Rotate90FlipNone

'DECLARE FUNCTION GdipLoadImageFromFile LIB "GDIPLUS.DLL" ALIAS "GdipLoadImageFromFile" ( _
'    BYVAL pFilename AS STRING _                         ' *GDIPCONST WCHAR
'  , BYREF pImage AS DWORD _                             ' *GpImage
'    ) AS LONG                                           ' GpStatus <enum>

DECLARE FUNCTION GdipGetImageThumbnail LIB "GDIPLUS.DLL" ALIAS "GdipGetImageThumbnail" ( _
    BYVAL pImage AS DWORD _                             ' *GpImage
  , BYVAL thumbWidth AS DWORD _                         ' UINT
  , BYVAL thumbHeight AS DWORD _                        ' UINT
  , BYREF thumbImage AS DWORD _                         ' **GpImage
  , BYVAL pcallback AS DWORD _                          ' GetThumbnailImageAbort
  , BYVAL callbackData AS DWORD _                       ' *void
    ) AS LONG                                           ' GpStatus <enum>

DECLARE FUNCTION GdipImageRotateFlip LIB "GDIPLUS.DLL" ALIAS "GdipImageRotateFlip" ( _
    BYVAL pImage AS DWORD _                             ' *GpImage
  , BYVAL rfType AS LONG _                              ' RotateFlipType <enum>
    ) AS LONG                                           ' GpStatus <enum>

DECLARE FUNCTION GdipBitmapGetPixel LIB "gdiplus.dll" ALIAS "GdipBitmapGetPixel" ( _
    BYVAL nBitmap&, BYVAL x&, BYVAL y&, Colr&) AS LONG

DECLARE FUNCTION GdipDisposeImage LIB "gdiplus.dll" ALIAS "GdipDisposeImage" ( _
    BYVAL nImage&) AS LONG
GLOBAL pixmap() AS STRING
GLOBAL texture() AS LONG


' ========================================================================================
' DLL_API FIBITMAP *DLL_CALLCONV FreeImage_Load(FREE_IMAGE_FORMAT fif, const char *filename,
' int flags FI_DEFAULT(0));
' ========================================================================================
DECLARE FUNCTION FreeImage_Load _
   LIB "FreeImage.dll" ALIAS "_FreeImage_Load@12" ( _
   BYVAL LONG, _                       ' FREE_IMAGE_FORMAT fif
   BYREF ASCIIZ, _                     ' const char *filename
   OPTIONAL BYVAL LONG _               ' int flags FI_DEFAULT(0)
   ) AS DWORD                          ' FIBITMAP *
' ========================================================================================


' ========================================================================================
' DLL_API FIBITMAP *DLL_CALLCONV FreeImage_Rescale(FIBITMAP *dib, int dst_width,
' int dst_height, FREE_IMAGE_FILTER filter);
' ========================================================================================
DECLARE FUNCTION FreeImage_Rescale _
   LIB "FreeImage.dll" ALIAS "_FreeImage_Rescale@16" ( _
   BYVAL DWORD, _                      ' FIBITMAP *dib
   BYVAL LONG, _                       ' int dst_width
   BYVAL LONG, _                       ' int dst_height
   BYVAL LONG _                        ' FREE_IMAGE_FILTER filter
   ) AS DWORD                          ' FIBITMAP *
' ========================================================================================

' ========================================================================================
' DLL_API BOOL DLL_CALLCONV FreeImage_FlipVertical(FIBITMAP *dib);
' ========================================================================================
DECLARE FUNCTION FreeImage_FlipVertical _
   LIB "FreeImage.dll" ALIAS "_FreeImage_FlipVertical@4" ( _
   BYVAL DWORD _                       ' FIBITMAP *dib
   ) AS LONG                           ' BOOL
' ========================================================================================


' ========================================================================================
' DLL_API BOOL DLL_CALLCONV FreeImage_GetPixelColor(FIBITMAP *dib, unsigned x, unsigned y,
' RGBQUAD *value);
' ========================================================================================
DECLARE FUNCTION FreeImage_GetPixelColor _
   LIB "FreeImage.dll" ALIAS "_FreeImage_GetPixelColor@16" ( _
   BYVAL DWORD, _                      ' FIBITMAP *dib
   BYVAL DWORD, _                      ' unsigned x
   BYVAL DWORD, _                      ' unsigned y
   BYREF LONG _                     ' RGBQUAD *value
   ) AS LONG                           ' BOOL
' ========================================================================================


' ========================================================================================
' DLL_API void DLL_CALLCONV FreeImage_Unload(FIBITMAP *dib);
' ========================================================================================
DECLARE SUB FreeImage_Unload _
   LIB "FreeImage.dll" ALIAS "_FreeImage_Unload@4" ( _
   BYVAL DWORD _                       ' FIBITMAP *dib
   )                                   ' void
' ========================================================================================


SUB TexImage (img AS STRING, ref AS LONG, p AS LONG )
   #REGISTER NONE
   LOCAL pBitmap,pThumb AS LONG
   pixmap(ref)=NUL$(4*256*256) ' GLOBAL pixmap()
   GdipLoadImageFromFile((UCODE$(img)), pBitmap)
   GdipGetImageThumbnail ( pBitMap, 256, 256, pThumb, 0, 0 )
   GdipImageRotateFlip(pThumb,%RotateNoneFlipY) 'invert
   'LOCAL zFileName AS ASCIIZ*128
   'zFileName=img
   'LOCAL h,t AS LONG
   'h=FreeImage_Load (2,zFileName,0) ' -1 unkn 2 jpeg 13 png
   't=FreeImage_Rescale (h,256,256,0)
   ''FreeImage_FlipVertical t ' No need to flip with FreeImage
   DIM w AS LONG PTR
   p=STRPTR(pixmap(ref))
   w=p
   LOCAL x,y AS LONG
   FOR y=0 TO 255
    FOR x=0 TO 255
     GdipBitmapGetPixel pThumb, x, y, @w
     'FreeImage_GetPixelColor t,x,y,@w
     ' RED BLUE SWAP FOR OPENGL
     ! mov edx,w
     ! mov al,[edx]
     ! xchg al,[edx+2]
     ! mov [edx],al
     '! mov byte ptr [edx+3],255 ' with FREEIMAGE we must set jpeg alpha
     ! add dword ptr w,4
    NEXT
   NEXT
   GdipDisposeImage pBitmap
   GdipDisposeImage pThumb
   'FreeImage_Unload h
   'FreeImage_Unload t
   DIM pp AS BYTE PTR
   pp=p
   glBindTexture GL_TEXTURE_2D, texture(ref) ' GLOBAL texture()
   glTexParameterf GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR
   glTexParameterf GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR
   '             target      level components width height  border format   datatype      ptr to image data
   glTexImage2D GL_TEXTURE_2D, 0,      4, 256, 256, 0, GL_RGBA, GL_UNSIGNED_BYTE, @pp
END SUB

SUB MakeTex(texNum AS LONG ,PixelArray() AS BYTE , xSize AS LONG, ySize AS LONG )
    glBindTexture GL_TEXTURE_2D, texNum
    glTexParameteri GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR
    glTexParameteri GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR '_MIPMAP_LINEAR ' _MIPMAP_LINEAR
    glTexImage2D GL_TEXTURE_2D, 0, 4, xSize, ySize, 0, GL_RGBA, GL_UNSIGNED_BYTE, PixelArray(0)
END SUB


'---------------------------------------
' GEOMETRICA extracts
'---------------------------------------
TYPE vector3dv
    x AS DOUBLE
    y AS DOUBLE
    z AS DOUBLE
END TYPE

TYPE vector3fv
    x AS SINGLE
    y AS SINGLE
    z AS SINGLE
END TYPE

TYPE vector4fv
    r AS SINGLE
    g AS SINGLE
    b AS SINGLE
    a AS SINGLE
END TYPE

SUB planet(sz AS SINGLE,ds AS SINGLE)
  #REGISTER NONE
  LOCAL i AS DWORD
  LOCAL j AS DWORD
  LOCAL pi AS SINGLE:pi=ATN(1)*4
  LOCAL dtr AS SINGLE: dtr=pi/180
  LOCAL x  AS SINGLE
  LOCAL y1 AS SINGLE
  LOCAL y2 AS SINGLE
  LOCAL z  AS SINGLE
  LOCAL v1 AS SINGLE
  LOCAL v2 AS SINGLE
  LOCAL st AS DWORD: st=MAX(INT(ds/(50*sz))*10, 5) 'reduce triangle count with distance/size
  LOCAL a  AS SINGLE
  glPushMatrix
  glScalef sz,sz,sz
  'glColor4f 0.9,0.4,0.1,1
  FOR j=0 TO 180-st STEP st
   y1=COS(j*dtr):y2=COS((j+st)*dtr)
   v1=SQR(1-(y1*y1)): v2=SQR(1-(y2*y2))
   glbegin GL_TRIANGLE_STRIP
   FOR i=0 TO 360 STEP st ' use 180 for front half only
    a=i*dtr:x=COS(a)*v1:z=SIN(a)*v1
    glTexCoord2f 1-i/360, ((1-j)/180)
    glNormal3f  x+x, y1+y1, z+z
    glVertex3f  x, y1, z
    x=COS(a)*v2:z=SIN(a)*v2
    glTexCoord2f 1-i/360, ((1-(j+st))/180)
    glNormal3f  x+x, y2+y2, z+z
    glVertex3f  x, y2, z
   NEXT i
   glEnd
  NEXT j
  glPopMatrix
 END SUB

'---------------------------------------
' END GEOMETRICA
'---------------------------------------


' Key State Masks for Mouse Messages
%MK_LBUTTON                     = &H0001
%MK_RBUTTON                     = &H0002
%MK_SHIFT                       = &H0004
%MK_CONTROL                     = &H0008
%MK_MBUTTON                     = &H0010
%MK_XBUTTON1                    = &H0020
%MK_XBUTTON2                    = &H0040

%WM_MOUSEMOVE                   = &H200
%WM_LBUTTONDOWN                 = &H201
%WM_LBUTTONUP                   = &H202
%WM_LBUTTONDBLCLK               = &H203
%WM_RBUTTONDOWN                 = &H204
%WM_RBUTTONUP                   = &H205
%WM_RBUTTONDBLCLK               = &H206
%WM_MBUTTONDOWN                 = &H207
%WM_MBUTTONUP                   = &H208
%WM_MBUTTONDBLCLK               = &H209
%WM_MOUSEWHEEL                  = &H20A
%WM_XBUTTONDOWN                 = &H20B
%WM_XBUTTONUP                   = &H20C
%WM_XBUTTONDBLCLK               = &H20D

' Keyboard messages
%WM_KEYDOWN                     = &H100
%WM_KEYUP                       = &H101
%WM_CHAR                        = &H102
%WM_DEADCHAR                    = &H103
%WM_SYSKEYDOWN                  = &H104
%WM_SYSKEYUP                    = &H105
%WM_SYSCHAR                     = &H106
%WM_SYSDEADCHAR                 = &H107

%MAXOB                          = 100

'ADDITIONAL API CALLS
DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION wglMakeCurrent LIB "OPENGL32.DLL" ALIAS "wglMakeCurrent" (BYVAL hdc AS DWORD, BYVAL hglrc AS DWORD) AS LONG
DECLARE FUNCTION GetFocus LIB "USER32.DLL" ALIAS "GetFocus" () AS DWORD
DECLARE FUNCTION SetFocus LIB "USER32.DLL" ALIAS "SetFocus" (BYVAL hWnd AS DWORD) AS LONG


'SCENE ELEMENTS
DECLARE SUB main_lighting(b AS SINGLE,d AS SINGLE, s AS SINGLE, a AS SINGLE, m AS SINGLE)
DECLARE SUB make_stick(BYVAL lis AS LONG)

'GEODESIC
DECLARE SUB spherepoints(BYVAL x AS SINGLE ,BYVAL y AS SINGLE ,BYVAL z AS SINGLE, BYVAL s AS SINGLE, BYVAL t AS SINGLE, BYREF v AS vector3fv, BYREF n AS vector3fv)
DECLARE SUB cubesphere(BYVAL s AS SINGLE)

DECLARE SUB planet(sz AS SINGLE,ds AS SINGLE)
DECLARE SUB capsule(dist AS SINGLE)

'GLOBAL gColor() AS LONG
'GLOBAL gsR(), gsG(), gsB() AS SINGLE


'// The main exported plugin's function would be bbProc, like this:
FUNCTION BBProc ALIAS "BBProc" (BYREF BBP AS BBPLUGIN) EXPORT AS LONG
    #REGISTER NONE

    LOCAL i,j,k,l AS LONG
    'default_material:
    'DIM ambi(3)  AS STATIC GLfloat
    'DIM diff(3)  AS STATIC GLfloat
    'DIM spec(3)  AS STATIC GLfloat
    'DIM emis(3)  AS STATIC GLfloat
    'DIM shine(0) AS STATIC GLfloat
    LOCAL x, y AS LONG
    LOCAL nRet, Msg, wParam, lParam AS LONG
    STATIC Mx, My, MDown,req_pick AS LONG
    'STATIC UseFont AS ZGLFONT
    ' object rotation
    'DIM Cx(%MAXOB) AS STATIC SINGLE
    'DIM Cy(%MAXOB) AS STATIC SINGLE
    'DIM Cz(%MAXOB) AS STATIC SINGLE
    'DIM px(%MAXOB) AS STATIC SINGLE
    'DIM py(%MAXOB) AS STATIC SINGLE
    'DIM pz(%MAXOB) AS STATIC SINGLE
    DIM texture(128) AS GLOBAL LONG
    DIM inds(200) AS STATIC SINGLE
    DIM vf(64*200) AS STATIC SINGLE ' audio frames
    DIM pixmap(32) AS GLOBAL STRING
    DIM zd(64) AS STATIC SINGLE
    STATIC ptr_wglSwapIntervalEXT AS DWORD
    STATIC atten AS SINGLE
    STATIC stt AS LONG       ' rota index to land strips
    STATIC init AS LONG      ' init flag enables inialisation and partial re-initialisation
    STATIC inito AS LONG     ' plugin flag to indicate one initialisation has taken place
    STATIC frc AS LONG       'frame count
    STATIC lmode AS LONG     ' mode of landscape movement
    STATIC landsz AS LONG    ' number of land strips in the landscape
    STATIC renewable AS LONG ' allows new strips of lanscape to be created (modulated by fft)
    STATIC ts1,ts2,ts3,ts4,ts5,ts6,ts7,ts8,ts9 AS QUAD ' for timestamps
    STATIC tt1,tt2,tt3,tt4,tt5,tt6,tt7,tt8,tt9 AS QUAD ' for timestamps
    STATIC er1,er2,er3,er4 AS LONG ' error checks

    nRet = %BBP_SUCCESS
    'if bbp.msg=5 then msgbox "Keyboard message received by plugin": function=nret:exit function

    SELECT CASE LONG BBP.Msg

    CASE %BBP_CREATE

         '// Retrieve plugin details
         'msgbox "create"
         BBP.Title    = "Soundscape A"
         BBP.Author   = "Charles Pegge"
         BBP.Version  = MAKDWD(1, 0) '// Version 1.0"
         BBP.RenderTo = %BBP_OPENGL  '// or %BBP_GDIPLUS, or %BBP_DIRECTX

    CASE %BBP_INIT

         IF inito>0 THEN EXIT FUNCTION ' allow initialisation once only
         inito=1
         '// Do your code initialisation there
         'MSGBOX "init"



         FOR i=0 TO 64: zd(i)=RND*.3:NEXT ' vertex randomised z displacement
         BBP.RenderTo = %BBP_OPENGL   '// or %BBP_GDIPLUS, or %BBP_DIRECTX
         wglMakeCurrent BBP.DC, BBP.RC
         glClear GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT


         glClearColor 0,0,0,1
         'glGenLists 128

         'TRANSPARENT OVERLAYS
         glNewList 2, GL_COMPILE
         'glBegin GL_QUADS
         'glcolor4f 0.1,0.2,0.8,0.02
         'glvertex3f  -2,-2, 0: glvertex3f   2,-2,0
         'glvertex3f   2, 2, 0: glvertex3f  -2, 2,0
         'glend
         glBegin GL_TRIANGLE_FAN
         glcolor4f 0.1,0.2,0.8,0.02
         glvertex3f   0,  0, 0
         glcolor4f 0.1,0.2,0.8,0.005
         glvertex3f  -2, -2, 0
         glvertex3f   2, -2, 0
         glvertex3f   2,  2, 0
         glvertex3f  -2,  2, 0
         glvertex3f  -2, -2, 0
         glend
         glEndList

         glNewList 3, GL_COMPILE
         planet 5,50
         glEndList


         'STARRY BACKGOUND
         glNewList 5, GL_COMPILE
         RANDOMIZE 2468
         i=0
         glEnable GL_POINT_SMOOTH
         glPointSize 1
         glbegin GL_POINTS
         'glcolor3f 1,1,1
         'RANDOMIZE 123
         DO
             INCR i:IF i>2000 THEN EXIT DO
             IF i=1500 THEN glend: glPointSize 2: glbegin GL_POINTS
             IF i=1900 THEN glend: glPointSize 3: glbegin GL_POINTS
             IF i=1950 THEN glend: glPointSize 4: glbegin GL_POINTS
             glcolor3f  RND,RND,RND
             glvertex3f RND*120-60,RND*120-60,-100
         LOOP
         glend
         glDisable GL_POINT_SMOOTH
         glPointSize 1
         glEndList


         'MSGBOX "init"
         'render_settings:
         glShadeModel GL_SMOOTH                            'Enable Smooth Shading
         'glClearColor cl(0,0), cl(1,0), cl(2,0), cl(3,0)  'Background
         glClearDepth 1.0                                  'Depth Buffer Setup
         glEnable GL_DEPTH_TEST                            'Enables Depth Testing
         glDepthFunc GL_LEQUAL                             'The Type Of Depth Testing To Do
         glHint GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST  'Really Nice Perspective Calculations
         'glEnable GL_LIGHTING                             'Enable Lighting
         glEnable GL_COLOR_MATERIAL                        'Enable Coloring Of Material
         glBlendFunc GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA  'Enable Alpha Blending
         glEnable GL_BLEND                                 'Enable Blending
         glEnable GL_ALPHA_TEST                            'Enable Alpha Testing
         glAlphaFunc GL_ALWAYS,0.0                         'Set Alpha Testing
         'glDisable GL_CULL_FACE                           'Remove front or Back Face
         glEnable GL_TEXTURE_2D
         GOSUB generate_textures
         '
         renewable=1
         lmode=1
         landsz=70
         atten=1
         'stt=0
         init=1
         j=landsz*64
         FOR i=0 TO j:vf(i)=0.75*RND:NEXT ' initial landscape
         FOR i=0 TO landsz: inds(i)=i:NEXT ' landscape slice index

    CASE %BBP_RENDER


         '// FFT MAGIC!
         '// BBP.FFTsize returns a pointer to an area of memory containing an array of 256 singles.
         '// This is then mapped to the fft() array where it can be accessed.
         DIM fft(BBP.FFTsize) AS SINGLE AT BBP.FFTdata
         INCR frc
         IF frc=1 THEN
             TimeStamp ts1
             'IF req_pick=1 THEN
             '    DIM SelObject AS STATIC LONG
             '    DIM hits AS LONG
             '    GOSUB pick_object
             '    req_pick=0
             '    'MSGBOX "pick "+str$(SelObject)+str$(hits)
             'END IF
             GOSUB prepare_scene
             er1=glGetError
             TimeStamp ts2
             EXIT FUNCTION
         END IF
         IF frc>1 THEN
             frc=0
         END IF
         '
         ts5=ts6: TimeStamp ts6
         tt5=tt6: QueryPerformanceCounter tt6
         TimeStamp ts3
         'GOSUB default_material
         wglMakeCurrent BBP.DC, BBP.RC
         'TimeStamp ts7
         glLoadIdentity
         gluLookAt 0.0, 0.0, 5.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0
         glClear GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT
         glClear GL_DEPTH_BUFFER_BIT
         'TimeStamp ts8
         GOSUB render_scene
         er2=glGetError
         TimeStamp ts4
         ' FRAME SYNC experimental (assumes 1 nanosecond)
         'IF ts9>0 THEN
         '    tt1=ts4+33000000
         '    DO
         '        timeStamp ts9
         '        IF ts9>=tt1 THEN EXIT DO
         '        ' do useful things here
         '    LOOP
         '    ts9=tt1
         'END IF
         'IF ts9=0 THEN TimeStamp ts9

    CASE %BBP_SIZE

         '// The size of the view port has changed.
         LOCAL rAspect AS DOUBLE, rc AS RECT
         GetClientRect BBP.ParentWindow, rc

         glMatrixMode GL_PROJECTION
         glLoadIdentity
         rAspect = 1.5: IF rc.nBottom THEN rAspect = rc.nRight / rc.nBottom
         gluPerspective 35.0, rAspect, 0.1, 1500.0
         glMatrixMode GL_MODELVIEW



    CASE %BBP_DESTROY

         '// Free up your resources there

         IF inito=0 THEN EXIT FUNCTION

         'req_pick=0

         glDeleteLists 1, 128
         glDeleteTextures 32, texture(0)
         er3=glGetError

         ' REPORT
         QueryPerformanceFrequency tt2
         OPEN "BBplugin\SoundscapeReport.txt" FOR OUTPUT AS 1
         PRINT #1,"Soundscape Diagnostics"
         PRINT #1,""
         PRINT #1,""
         PRINT #1, "Phase 1 prepare scene: ";ts2-ts1
         PRINT #1, "Phase 2 render scene:  ";ts4-ts3
         PRINT #1, "2 Frame Interval:      ";ts6-ts5
         'PRINT #1, "wglMakeCurrent:        ";ts7-ts6
         'PRINT #1, "clear buffers etc:     ";ts8-ts7
         PRINT #1,""
         TimeStamp tt3
         QueryPerformanceCounter tt1
         PRINT #1,"Frame interval rt       :   ";(tt6-tt5)/tt2
         PRINT #1,"Frame per sec rtt       :   ";tt2/(tt6-tt5)
         PRINT #1,""
         PRINT #1,"QueryPerformance Frequency: ";tt2
         PRINT #1,""
         PRINT #1, "Error checks:           ";HEX$(er1),HEX$(er2),HEX$(er3)
         PRINT #1,""
         CLOSE #1
         '
         'msgbox "Destroy"


    CASE %BBP_MOUSE
         '// Handle all Windows mouse messages there
         Msg = BBP.WinMsg: wParam = BBP.wParam: lParam = BBP.lParam

         SELECT CASE LONG Msg
         'CASE %WM_MOUSEMOVE
         '     x = LO(WORD, lParam): y = HI(WORD, lParam)
         '     IF MDown = %MK_LBUTTON THEN
         '        Cy(SelObject) = Cy(SelObject) + (x - Mx)
         '        Cx(SelObject) = Cx(SelObject) + (y - My)
         '        px(SelObject)=px(SelObject)+(x-Mx)*(.02-pz(SelObject)*.001)
         '        py(SelObject)=py(SelObject)+(My-y)*(.02-pz(SelObject)*.001)
         '     ELSEIF MDown = %MK_RBUTTON THEN
         '        Cy(SelObject) = Cy(SelObject) + (x - Mx)
         '        Cz(SelObject) = Cz(SelObject) + (y - My)
         '        pz(SelObject)=pz(SelObject)+(y-My)*.5
         '        px(SelObject)=px(SelObject)+(x-Mx)*(.02-pz(SelObject)*.001)
         '     END IF
         '     Mx = x: My = y
         '
         CASE %WM_LBUTTONDOWN, %WM_RBUTTONDOWN      ', %WM_MBUTTONDOWN, %WM_XBUTTONDOWN

              Mx = LO(WORD, lParam): My = HI(WORD, lParam)
              IF wParam = %MK_LBUTTON OR wParam = %MK_RBUTTON THEN MDown = wParam
              'req_pick=1 ' to perform object picking on the next render cycle
              'IF (Mx<100)AND(My<100) THEN renewable=1-renewable ' experimental control

         CASE %WM_LBUTTONUP, %WM_RBUTTONUP          ', %WM_MBUTTONUP, %WM_XBUTTONUP
              MDown = 0

         'CASE %WM_LBUTTONDBLCLK, %WM_RBUTTONDBLCLK ', %WM_MBUTTONDBLCLK, %WM_XBUTTONDBLCLK
         'CASE %WM_MOUSEWHEEL
         END SELECT

    CASE %BBP_KEYBOARD

        '// Handle all Windows keyboard messages there
        Msg = BBP.WinMsg: wParam = BBP.wParam: lParam = BBP.lParam
        IF (Msg=%WM_KEYDOWN)OR(Msg=%WM_SYSKEYDOWN) THEN
            IF (wParam)=&h20 THEN '
               INCR lmode: IF lmode>1 THEN lmode=0
               stt=0:init=1:FOR i=0 TO landsz*64:vf(i)=0.75*RND:NEXT ' initial landscape
               FOR i=0 TO landsz: inds(i)=i:NEXT ' landscape slice index

               'FOR i=0 TO %MAXOB
               '     Cx(i)=0: Cy(i)=0: Cz(i)=0 ' reset object orientation
               ' NEXT
               ' Cx(0)=15
            END IF
        END IF
        IF (Msg=%WM_KEYUP)OR(Msg=%WM_SYSKEYUP) THEN
         'beep
        END IF

    CASE ELSE

        nRet = %BBP_ERROR

    END SELECT

    FUNCTION = nRet
    EXIT FUNCTION



'OPENGL SUBROUTINES
'-----------------------------------------------


generate_textures:
         glGenTextures 32, texture(0)
         '
         'IF GLSL THEN
         '    ! push GL_TEXTURE0
         '    ! call glActiveTexture
         'END IF
         '
         TexImage $BBP_PLUGIN_FOLDER + "Texture\venus.jpg",1,i
         '
         DIM pix(&h1000) AS BYTE ' upto 32*32 * (32 bit pixel)
         LOCAL b,p AS BYTE PTR
         b=VARPTR(pix(0))
         p=b+20 ' (1*4+1)*4
         ' set single pixel at y=1:x=1
         @p=255:INCR p ' red
         @p=255:INCR p ' green
         @p=255:INCR p ' blue
         @p=255:INCR p ' alpha
         MakeTex Texture(2), pix(), 4, 4
         p=b
         i=1
         ' base background
         DO
             IF i>=&h1000 THEN EXIT DO
             @p[i]=180
             i=i+2
             @p[i]=255
             i=i+2
         LOOP
         i=0
         @p=b
         DO
          IF i>800 THEN EXIT DO '200 800
             j=(RND*&h1000) AND &hfffc
             'j=(RND*&h400) AND &hfffc
             @p[j]=72:INCR j
             @p[j]=155+100*RND:INCR j
             @p[j]=0:INCR j
             INCR i
         LOOP

         'MakeTex Texture(3), pix(), 32,32
         MakeTex Texture(3), pix(), 16,16
         'darker shade
         'finer tex
         FOR i=0 TO &h0fff STEP 4
             j=i
             pix(j)=pix(j)*.4:INCR j
             pix(j)=pix(j)*.54:INCR j
             pix(j)=pix(j)*.54
         NEXT
         MakeTex Texture(4), pix(), 16,16
         ' new detail
         REDIM pix1(&h4000) AS BYTE
         LOCAL f AS SINGLE
         FOR i=0 TO &h0fff STEP 4
             FOR k=0 TO 15 STEP 4
                 j=i
                 f=RND*.4+.6:pix1(j+k+i*3)=pix(j)*f:INCR j
                 f=RND*.4+.6:pix1(j+k+i*3)=pix(j)*f:INCR j
                 f=RND*.4+.6:pix1(j+k+i*3)=pix(j)*f:INCR j
                 pix1(j+k+i*3)=pix(j) 'A
             NEXT k
         NEXT i

         MakeTex Texture(5), pix(), 32,32
         'MakeTex Texture(5), pix1(), 64,64

RETURN


prepare_scene:
         '--------------
         ' SOUNDSCAPE
         '--------------

         LOCAL ds,ds1 AS SINGLE
         LOCAL sts,i1,i2,newdata AS LONG
         LOCAL cl AS vector4fv
         LOCAL v,v1,v2,vk AS SINGLE
         DIM ve AS LOCAL vector3fv
         j=landsz
         i=j+2
         'static stt
         DO
             i=i-2: IF i<0 THEN EXIT DO
             stt=i
             IF lmode =0 THEN inds(i)=inds(i)+0.5: IF inds(i)>j THEN inds(i)=inds(i)-j ' landscape receding
             IF lmode=1 THEN inds(i)=inds(i)-.5: IF inds(i)<0 THEN inds(i)=inds(i)+j  ' landscape approaching
         LOOP
         i=j+2
         DO
             i=i-2: IF i<0 THEN EXIT DO
             sts=stt:stt=stt+2: IF stt>j THEN stt=0 ' loop round  rendering front to back
             ds=inds(stt)
             IF (ds<0.05)AND(renewable=1) THEN
                 'audio_spectrum:
                 newdata=1
                 k=0
                 IF lmode=1 THEN i1=stt '*64
                 IF lmode=0 THEN i1=sts '*64
                 SHIFT LEFT i1,6
                 DO
                     IF k>=64 THEN EXIT DO
                     v=SQR(fft(k+8))*8*atten
                     IF v>2 THEN atten=2/v:v=2 ' attenuation
                     IF v=0 THEN v=RND*.4: atten=1 ' restore sensitivity
                     vf(i1)=v
                     'vf(i1)=vf(i1)*.5+SQR(fft(k))*4 ' averaged height
                     INCR k: INCR i1
                 LOOP
             END IF
             IF init THEN newdata=1
             ds1=-ds ' z spacing
             IF ds<=j THEN ' detail
                 '
                 IF newdata THEN
                     i2=sts: SHIFT LEFT i2,6 ' *64
                     i1=stt: SHIFT LEFT i1,6 ' *64
                     glNewList stt+16, GL_COMPILE
                     glbegin GL_QUADS
                     vk=0
                     DO
                         IF vk>62 THEN EXIT DO
                         'far left
                         v1=vk*.25
                         v=vf(i1)
                         ve.x=v1-8
                         ve.y=v
                         ve.z=zd(vk)
                         glcolor3f v,v,v
                         'void glMultiTexCoord2f( GLenum   target
                         glTexcoord2d 0,1
                         glvertex3fv  ve.x
                         'near left
                         v=vf(i2)
                         ve.y=v
                         ve.z=ve.z+2
                         glcolor3f v,v,v
                         'void glMultiTexCoord2f( GLenum   target
                         glTexcoord2d 0,0
                         glvertex3fv  ve.x
                         vk=vk+1
                         INCR i1
                         INCR i2
                         ' near right
                         v1=vk*.25
                         v=vf(i2)
                         ve.x=v1-8
                         ve.y=v
                         ve.z=2+zd(vk)
                         v=vf(i2)
                         ve.y=v
                         glcolor3f v,v,v
                         'void glMultiTexCoord2f( GLenum   target
                         glTexcoord2d 1,0
                         glvertex3fv  ve.x
                         ' far right
                         v=vf(i1)
                         ve.y=v
                         ve.z=ve.z-2
                         glcolor3f v,v,v
                         'void glMultiTexCoord2f( GLenum   target
                         glTexcoord2d 1,1
                         glvertex3fv  ve.x
                     LOOP
                     glEnd
                     glEndList
                     newdata=0
                 END IF
             END IF
         LOOP
         init=0
RETURN ' end of prepare scene





render_scene:

         '// Very important we must reassign glRC to the new glDC
         '// Note: don't use permanent DC, this produce better and smoother display



         'SLOW GYRATION
         STATIC rx1,ry1,rz1 AS SINGLE
         rx1=(rx1+0.02) MOD 360
         ry1=(ry1+0.022) MOD 360
         rz1=(rz1+0.024) MOD 360

         glcolor3f 1,1,1

         'STARS
         glPushMatrix
         glRotatef rz1,0,0,1
         glCallList 5
         glPopMatrix


         'PLANET
         glEnable GL_TEXTURE_2D
         glBindTexture GL_TEXTURE_2D,texture(1)
         glLoadName 1
         glpushmatrix
         gltranslatef 15,12,-60
         GOSUB gyrate_slowly
         glCallList 3
         glpopmatrix

         glcolor3f 1,1,1

         glDisable GL_TEXTURE_2D


         '--------------
         ' SOUNDSCAPE
         '--------------

         glBindTexture GL_TEXTURE_2D,texture(4)

         'LOCAL ds,ds1 AS SINGLE
         'LOCAL sts,i1,i2,newdata AS LONG
         glPushMatrix
         glScalef 2.2,1.5,.5
         glRotatef 2,1,0,0
         'GOSUB gyrate_slowly
         j=landsz
         i=j+2
         DO
             i=i-2: IF i<0 THEN EXIT DO
             sts=stt:stt=stt+2: IF stt>j THEN stt=0 ' loop round  rendering front to back
             ds=inds(stt)
             ds1=-ds ' z spacing
             IF ds<=j THEN ' detail
                 glPushMatrix
                 glTranslatef 0,-3,ds1
                 IF ds>=j-10 THEN
                  v1=(j-ds)*0.1
                  glScalef 1,v1,1
                 END IF
                 IF ds<1 THEN
                     glScalef 1,ds,1
                 END IF
                 glEnable GL_TEXTURE_2D
                 glCallList stt+16
                 glDisable GL_TEXTURE_2D
                 glPopMatrix
             END IF
         LOOP
         glPopMatrix
         i=0
         glPushMatrix
         glScalef 7,3,1
         gltranslatef 0,0.25,-20
         'DO
         '    IF i>12 THEN EXIT DO
         '    glTranslatef 0,0,1
         '    glCallList 2 ' transparent blue overlays
         '    INCR i
         'LOOP
         glPopMatrix
         '
         ' diffuse atmosphere
         glBegin GL_TRIANGLE_FAN
         glcolor4f 0.1,0.2,0.8,0.4
         glvertex3f  0,0,-15
         glcolor4f 0.1,0.2,0.8,0.0
         glvertex3f  -20,-1, 2
         glvertex3f   20,-1, 2
         glvertex3f   20, 6, -1
         glvertex3f  -20, 6, -1
         glvertex3f  -20,-1, 2
         glend

         glFlush

RETURN ' end of scene


'-----------------------------------------------

gyrate_slowly:
         glRotatef  rx1, 1.0, 0.0, 0.0
         glRotatef  ry1, 0.0, 1.0, 0.0
         glRotatef  rz1, 0.0, 0.0, 1.0
RETURN

#IF 0
pick_object:
           'glLoadName
           '
           'UNION CRECT
           '    rc AS    RECT
           '    rl(3) AS LONG
           'END UNION
           LOCAL rct AS CRECT
           LOCAL vv,w,c AS LONG
           LOCAL HitDetection AS LONG
           GetClientRect BBP.ParentWindow, rct.rc

           SelObject=0    ' number/name of selected object
           HitDetection=1 ' flag used to indicated selection mode
           glInitNames
           DIM SelectBuf(1023) AS LONG
           glSelectBuffer 1024, selectBuf(0)
           glRenderMode GL_SELECT
           glPushName (-1) ' an arbitrary value
           glMatrixMode GL_PROJECTION
           glLoadIdentity

           glGetIntegerv GL_VIEWPORT,rct.rl(0)
           gluPickMatrix  Mx, rct.rl(3)-My, 1.0, 1.0, rct.rl(0) ' single pixel selection zone
           gluPerspective 35.0, rct.rc.nRight/rct.rc.nBottom, 0.1, 1500.0
           glMatrixMode GL_MODELVIEW
           GOSUB render_scene
          'GOSUB render_control_panel
          '
          glPopName
  '
          hits=glRenderMode GL_RENDER
          HitDetection=0
          glMatrixMode GL_PROJECTION
          glLoadIdentity
          'nearest named object
          vv=&h7fffffff
          w=0
          i=0
          c=hits*4
           DO
               IF i>=c THEN EXIT DO
               IF SelectBuf(i+1)<=vv THEN vv=SelectBuf(i+1): w=SelectBuf(i+3) 'resolve by depth order
               i=i+SelectBuf(i)+3 ' step to next
           WEND
           SelObject=w
           gluPerspective 35.0, rct.rc.nRight/rct.rc.nBottom, 0.1, 1500.0
           glMatrixMode GL_MODELVIEW

RETURN
#ENDIF



END FUNCTION
